local AddonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary

c.Init(a)

------------------------------------------------------------------------ Common

-------------------------------------------------------------------- Windwalker
c.RegisterAura("Tiger Palm", "Tiger Power")

local function addWindwalkerSpell(name, tag, attributes)
	local spell = c.AddSpell(name, tag, attributes)
	spell.NoStopChannel = true
end

local function addOptionalWindwalkerSpell(name, tag, attributes)
	local spell = c.AddOptionalSpell(name, tag, attributes)
	spell.NoStopChannel = true
end

addWindwalkerSpell("Tiger Palm", "for Tiger Power", {
	CheckFirst = function()
		local stack = c.GetBuffStack("Tiger Power")
		local duration = c.GetBuffDuration("Tiger Power")
		if c.IsAuraPendingFor("Tiger Palm") then
			stack = stack + 1
			duration = 20
		end
		return stack < 3 or duration < 1.5
	end
})

addWindwalkerSpell("Tiger Palm", "under Combo Breaker", {
	CheckFirst = function(z)
		return c.HasBuff("Combo Breaker: Tiger Palm")
			and not c.IsCasting("Tiger Palm")
	end
})

addWindwalkerSpell("Rising Sun Kick", "for Debuff", {
	CheckFirst = function()
		return not c.HasBuff("Rising Sun Kick")
			and not c.IsAuraPendingFor("Rising Sun Kick")
	end
})

addOptionalWindwalkerSpell("Expel Harm", nil, {
	CheckFirst = function()
		return s.HealthPercent("player") < 90
	end
})

addOptionalWindwalkerSpell("Expel Harm", "at Cap", {
	CheckFirst = function()
		return s.HealthPercent("player") < 90
			and s.MaxPower("player") - s.Power("player") < 10
	end
})

addWindwalkerSpell("Jab", "at Cap", {
	CheckFirst = function()
		return s.MaxPower("player") - s.Power("player") < 10
	end
})

addWindwalkerSpell("Tigereye Brew", nil, {
	CheckFirst = function()
		return c.GetBuffStack("Tigereye Brew") == 10
	end
})

addWindwalkerSpell("Fists of Fury", nil, {
	NoStopChannel = true,
	Melee = true,
	CheckFirst = function()
		return c.GetBuffDuration("Tiger Power") > 4
	end
})

addWindwalkerSpell("Blackout Kick", "under Combo Breaker", {
	NoStopChannel = true,
	CheckFirst = function(z)
		return c.HasBuff("Combo Breaker: Blackout Kick")
			and not c.IsCasting("Blackout Kick")
	end
})
